const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');

const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Infrastructure_statusesDBApi {
  static async create(data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const infrastructure_statuses = await db.infrastructure_statuses.create(
      {
        id: data.id || undefined,

        service: data.service || null,
        uptime_pct: data.uptime_pct || null,
        latency_ms: data.latency_ms || null,
        error_rate: data.error_rate || null,
        status: data.status || null,
        last_updated: data.last_updated || null,
        importHash: data.importHash || null,
        createdById: currentUser.id,
        updatedById: currentUser.id,
      },
      { transaction },
    );

    await infrastructure_statuses.setOrganization(
      currentUser.organization.id || null,
      {
        transaction,
      },
    );

    await infrastructure_statuses.setOrganizations(data.organizations || null, {
      transaction,
    });

    return infrastructure_statuses;
  }

  static async bulkImport(data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    // Prepare data - wrapping individual data transformations in a map() method
    const infrastructure_statusesData = data.map((item, index) => ({
      id: item.id || undefined,

      service: item.service || null,
      uptime_pct: item.uptime_pct || null,
      latency_ms: item.latency_ms || null,
      error_rate: item.error_rate || null,
      status: item.status || null,
      last_updated: item.last_updated || null,
      importHash: item.importHash || null,
      createdById: currentUser.id,
      updatedById: currentUser.id,
      createdAt: new Date(Date.now() + index * 1000),
    }));

    // Bulk create items
    const infrastructure_statuses = await db.infrastructure_statuses.bulkCreate(
      infrastructure_statusesData,
      { transaction },
    );

    // For each item created, replace relation files

    return infrastructure_statuses;
  }

  static async update(id, data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;
    const globalAccess = currentUser.app_role?.globalAccess;

    const infrastructure_statuses = await db.infrastructure_statuses.findByPk(
      id,
      {},
      { transaction },
    );

    const updatePayload = {};

    if (data.service !== undefined) updatePayload.service = data.service;

    if (data.uptime_pct !== undefined)
      updatePayload.uptime_pct = data.uptime_pct;

    if (data.latency_ms !== undefined)
      updatePayload.latency_ms = data.latency_ms;

    if (data.error_rate !== undefined)
      updatePayload.error_rate = data.error_rate;

    if (data.status !== undefined) updatePayload.status = data.status;

    if (data.last_updated !== undefined)
      updatePayload.last_updated = data.last_updated;

    updatePayload.updatedById = currentUser.id;

    await infrastructure_statuses.update(updatePayload, { transaction });

    if (data.organization !== undefined) {
      await infrastructure_statuses.setOrganization(
        globalAccess ? data.organization : currentUser.organization.id,
        { transaction },
      );
    }

    if (data.organizations !== undefined) {
      await infrastructure_statuses.setOrganizations(
        data.organizations,

        { transaction },
      );
    }

    return infrastructure_statuses;
  }

  static async deleteByIds(ids, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const infrastructure_statuses = await db.infrastructure_statuses.findAll({
      where: {
        id: {
          [Op.in]: ids,
        },
      },
      transaction,
    });

    await db.sequelize.transaction(async (transaction) => {
      for (const record of infrastructure_statuses) {
        await record.update({ deletedBy: currentUser.id }, { transaction });
      }
      for (const record of infrastructure_statuses) {
        await record.destroy({ transaction });
      }
    });

    return infrastructure_statuses;
  }

  static async remove(id, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const infrastructure_statuses = await db.infrastructure_statuses.findByPk(
      id,
      options,
    );

    await infrastructure_statuses.update(
      {
        deletedBy: currentUser.id,
      },
      {
        transaction,
      },
    );

    await infrastructure_statuses.destroy({
      transaction,
    });

    return infrastructure_statuses;
  }

  static async findBy(where, options) {
    const transaction = (options && options.transaction) || undefined;

    const infrastructure_statuses = await db.infrastructure_statuses.findOne(
      { where },
      { transaction },
    );

    if (!infrastructure_statuses) {
      return infrastructure_statuses;
    }

    const output = infrastructure_statuses.get({ plain: true });

    output.organization = await infrastructure_statuses.getOrganization({
      transaction,
    });

    output.organizations = await infrastructure_statuses.getOrganizations({
      transaction,
    });

    return output;
  }

  static async findAll(filter, globalAccess, options) {
    const limit = filter.limit || 0;
    let offset = 0;
    let where = {};
    const currentPage = +filter.page;

    const user = (options && options.currentUser) || null;
    const userOrganizations = (user && user.organizations?.id) || null;

    if (userOrganizations) {
      if (options?.currentUser?.organizationsId) {
        where.organizationsId = options.currentUser.organizationsId;
      }
    }

    offset = currentPage * limit;

    const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [
      {
        model: db.organizations,
        as: 'organization',
      },

      {
        model: db.organizations,
        as: 'organizations',
      },
    ];

    if (filter) {
      if (filter.id) {
        where = {
          ...where,
          ['id']: Utils.uuid(filter.id),
        };
      }

      if (filter.service) {
        where = {
          ...where,
          [Op.and]: Utils.ilike(
            'infrastructure_statuses',
            'service',
            filter.service,
          ),
        };
      }

      if (filter.uptime_pctRange) {
        const [start, end] = filter.uptime_pctRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            uptime_pct: {
              ...where.uptime_pct,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            uptime_pct: {
              ...where.uptime_pct,
              [Op.lte]: end,
            },
          };
        }
      }

      if (filter.latency_msRange) {
        const [start, end] = filter.latency_msRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            latency_ms: {
              ...where.latency_ms,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            latency_ms: {
              ...where.latency_ms,
              [Op.lte]: end,
            },
          };
        }
      }

      if (filter.error_rateRange) {
        const [start, end] = filter.error_rateRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            error_rate: {
              ...where.error_rate,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            error_rate: {
              ...where.error_rate,
              [Op.lte]: end,
            },
          };
        }
      }

      if (filter.last_updatedRange) {
        const [start, end] = filter.last_updatedRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            last_updated: {
              ...where.last_updated,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            last_updated: {
              ...where.last_updated,
              [Op.lte]: end,
            },
          };
        }
      }

      if (filter.active !== undefined) {
        where = {
          ...where,
          active: filter.active === true || filter.active === 'true',
        };
      }

      if (filter.status) {
        where = {
          ...where,
          status: filter.status,
        };
      }

      if (filter.organization) {
        const listItems = filter.organization.split('|').map((item) => {
          return Utils.uuid(item);
        });

        where = {
          ...where,
          organizationId: { [Op.or]: listItems },
        };
      }

      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map((item) => {
          return Utils.uuid(item);
        });

        where = {
          ...where,
          organizationsId: { [Op.or]: listItems },
        };
      }

      if (filter.createdAtRange) {
        const [start, end] = filter.createdAtRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            ['createdAt']: {
              ...where.createdAt,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            ['createdAt']: {
              ...where.createdAt,
              [Op.lte]: end,
            },
          };
        }
      }
    }

    if (globalAccess) {
      delete where.organizationsId;
    }

    const queryOptions = {
      where,
      include,
      distinct: true,
      order:
        filter.field && filter.sort
          ? [[filter.field, filter.sort]]
          : [['createdAt', 'desc']],
      transaction: options?.transaction,
      logging: console.log,
    };

    if (!options?.countOnly) {
      queryOptions.limit = limit ? Number(limit) : undefined;
      queryOptions.offset = offset ? Number(offset) : undefined;
    }

    try {
      const { rows, count } = await db.infrastructure_statuses.findAndCountAll(
        queryOptions,
      );

      return {
        rows: options?.countOnly ? [] : rows,
        count: count,
      };
    } catch (error) {
      console.error('Error executing query:', error);
      throw error;
    }
  }

  static async findAllAutocomplete(
    query,
    limit,
    offset,
    globalAccess,
    organizationId,
  ) {
    let where = {};

    if (!globalAccess && organizationId) {
      where.organizationId = organizationId;
    }

    if (query) {
      where = {
        [Op.or]: [
          { ['id']: Utils.uuid(query) },
          Utils.ilike('infrastructure_statuses', 'service', query),
        ],
      };
    }

    const records = await db.infrastructure_statuses.findAll({
      attributes: ['id', 'service'],
      where,
      limit: limit ? Number(limit) : undefined,
      offset: offset ? Number(offset) : undefined,
      orderBy: [['service', 'ASC']],
    });

    return records.map((record) => ({
      id: record.id,
      label: record.service,
    }));
  }
};
